'From Squeak 2.5 of August 6, 1999 on 16 September 1999 at 8:13:29 pm'!
"Change Set:		Comanche
Date:			18 August 1999
Author:			Bolot Kerimbaev

Comanche is a new generation Squeak web server.
It uses a modular architecture to allow great flexibility.
Web applications and services are modules.
Comanche supports multiple web servers on the same machine.
A web server is a high-level module.
Each module has (optionally) children modules.
Thus, modules form a tree.
Service modules (usually) do not have children.
Modules bundled include:
 * MultipartPostModule
 * AccessControlModule
 * DomainFilterModule
 * PingModule
 * FileServerModule
 * ActiveSqueakModule
 * ObjectServerModule
This model improve reuse of the standard components.
"!

Object subclass: #MIMEDocument
	instanceVariableNames: 'mainType subType content url '
	classVariableNames: 'MIMEdatabase '
	poolDictionaries: ''
	category: 'Network-Url'!
Object subclass: #AccessControlList
	instanceVariableNames: 'allowed denied defaultPermissions '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Comanche-Server'!
Object subclass: #ActiveSqueakPage
	instanceVariableNames: 'stream '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Comanche-Server'!
Object subclass: #Comanche
	instanceVariableNames: 'queue modules status process threads '
	classVariableNames: 'ComanchePreferences Queues Servers '
	poolDictionaries: ''
	category: 'Comanche-Server'!
Object subclass: #ComancheModule
	instanceVariableNames: 'name tempDir workDir status parent modules logfile '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Comanche-Server'!
ComancheModule subclass: #AccessControlModule
	instanceVariableNames: 'accessControlList '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Comanche-Server'!
ComancheModule subclass: #ActiveSqueakModule
	instanceVariableNames: 'compiledPagesCache '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Comanche-Server'!
ComancheModule subclass: #DomainFilterModule
	instanceVariableNames: 'allowedDomains deniedDomains '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Comanche-Server'!
ComancheModule subclass: #FileServerModule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Comanche-Server'!
ConnectionQueue subclass: #HttpConnectionQueue
	instanceVariableNames: 'server block '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Comanche-Server'!
Object subclass: #HttpRequest
	instanceVariableNames: 'url getFields postFields stream responseHeader cookies status operation '
	classVariableNames: 'HttpStatusCodeDict '
	poolDictionaries: ''
	category: 'Comanche-Server'!
HttpRequest subclass: #FileServerRequest
	instanceVariableNames: 'filename '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Comanche-Server'!
Dictionary subclass: #HttpStatus
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Comanche-Server'!
ComancheModule subclass: #MultipartPostModule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Comanche-Server'!
ComancheModule subclass: #ObjectServerModule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Comanche-ORB'!
HttpRequest subclass: #ObjectServerRequest
	instanceVariableNames: 'query uid '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Comanche-ORB'!
ComancheModule subclass: #PingModule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Comanche-Server'!
FileServerModule subclass: #PwsModule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Comanche-Server'!
HttpRequest subclass: #PwsRequest
	instanceVariableNames: 'peerName userId message fields log action '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Comanche-Server'!
ComancheModule subclass: #RedirectModule
	instanceVariableNames: 'redirectMap '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Comanche-Server'!
Stream subclass: #SocketStream
	instanceVariableNames: 'socket header status buffer inDataCount outDataCount '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Comanche-Server'!

!AccessControlList commentStamp: 'bolot 9/11/1999 16:20' prior: 0!
AccessControlList
3 Dictionaries

allowed = user->Set (actions)
denied = user->Set (actions)
defaultPermissions = action->boolean

by default HttpRequest's operation is nil
defaultPermissions at: nil is true
thus, an operation that's not defined is allowed unless denied!

!AccessControlList methodsFor: 'accessing' stamp: 'bolot 9/11/1999 16:25'!
allow: user toDo: action
	(denied includesKey: user)
		ifTrue: [(denied at: user) remove: action ifAbsent: []].

	(allowed at: user ifAbsent: [allowed at: user put: Bag new]) add: action! !

!AccessControlList methodsFor: 'accessing' stamp: 'bolot 8/18/1999 15:36'!
allowAllToDo: action
	denied do: [:user |
		user remove: action ifAbsent: []].

	defaultPermissions at: action put: false! !

!AccessControlList methodsFor: 'accessing' stamp: 'bolot 9/11/1999 16:25'!
deny: user toDo: action
	(allowed includesKey: user)
		ifTrue: [(allowed at: user) remove: action ifAbsent: []].

	(denied at: user ifAbsent: [denied at: user put: Bag new]) add: action! !

!AccessControlList methodsFor: 'accessing' stamp: 'bolot 8/18/1999 15:35'!
denyAllToDo: action
	allowed do: [:user |
		user remove: action ifAbsent: []].

	defaultPermissions at: action put: false! !

!AccessControlList methodsFor: 'accessing' stamp: 'bolot 8/18/1999 18:37'!
initialize
	allowed _ Dictionary new.
	denied _ Dictionary new.
	defaultPermissions _ Dictionary new.
	defaultPermissions at: nil put: true! !

!AccessControlList methodsFor: 'accessing' stamp: 'bolot 8/18/1999 15:32'!
is: user authorizedToDo: action
	((allowed at: user ifAbsent: ['']) includes: action)
		ifTrue: [^true].

	((denied at: user ifAbsent: ['']) includes: action)
		ifTrue: [^false].

	^(defaultPermissions at: action ifAbsent: [nil]) = true! !

!AccessControlList methodsFor: 'persistence' stamp: 'bolot 8/18/1999 15:28'!
saveTo: filename
	| f |
	f _ ReferenceStream fileNamed: filename.
	f nextPut: self.
	f close.! !


!AccessControlList class methodsFor: 'instance creation' stamp: 'bolot 9/11/1999 16:38'!
readProtectedFrom: aCollection
	"create an instance of me where users in aCollection
	are allowed to do the default operation, but nobody else"
	| acl |
	acl _ self new initialize.
	acl denyAllToDo: nil. "default permission for default operation is denied"
	aCollection do: [:aUser |
		acl allow: (self encode: aUser password: '') toDo: nil].
	^acl! !

!AccessControlList class methodsFor: 'instance creation' stamp: 'bolot 8/18/1999 15:27'!
restoreFrom: filename
	| f acl |
	f _ ReferenceStream fileNamed: filename.
	acl _ f next.
	f close.
	^acl! !

!AccessControlList class methodsFor: 'utilities' stamp: 'bolot 9/11/1999 16:38'!
encode: nameString password: pwdString
	"Encode per RFC1421 of the username:password combination."

	| clear code clearSize idx map |
	clear := (nameString, ':', pwdString) asByteArray.
	clearSize := clear size.
	[ clear size \\ 3 ~= 0 ] whileTrue: [ clear := clear, #(0) ].
	idx := 1.
	map := 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/'.
	code := WriteStream on: ''.
	[ idx < clear size ] whileTrue: [ code 
		nextPut: (map at: (clear at: idx) // 4 + 1);
		nextPut: (map at: (clear at: idx) \\ 4 * 16 + ((clear at: idx + 1) // 16) + 1);
   		nextPut: (map at: (clear at: idx + 1) \\ 16 * 4 + ((clear at: idx + 2) // 64) + 1);
   		nextPut: (map at: (clear at: idx + 2) \\ 64 + 1).
		idx := idx + 3 ].
	code := code contents.
	idx := code size.
	clear size - clearSize timesRepeat: [ code at: idx put: $=. idx := idx - 1].
	^code! !


!ActiveSqueakPage commentStamp: 'bolot 9/16/1999 19:46' prior: 0!
ActiveSqueakPage

proxy for ActiveSqueakModule's page variable
- this is the context within which the execution occurs
- used to limit access to only what we allow
!

!ActiveSqueakPage methodsFor: 'accessing' stamp: 'bolot 8/12/1999 01:23'!
privStream: aStream
	stream _ aStream! !

!ActiveSqueakPage methodsFor: 'accessing' stamp: 'bolot 8/12/1999 01:23'!
stream
	^stream! !


!Comanche commentStamp: '<historical>' prior: 0!
Comanche

a new web server for Squeak

The simultaneous connections are handled by HttpConnectionQueue
Comanche is not instantiated, but used for Server management and accounting
All processing happens inside ComancheModule (and subclasses) instances

HttpStream and HttpRequest handle incoming HTTP data
HttpResponse is used for outgoing HTTP data

When a connection is initiated, the root module is started with httpStartOnSocket:
which in turn produces an HttpRequest from the socket and calls process:

Module process: attempts to convert the HttpRequest to its "native" request format
If it fails, the request cannot be handled by the module
If a module handles the request, the request is processed as follows:
- module performs preprocessing
- each of its children modules do process: (see above - recursive)
- module performs postprocessing

A module may determine that its handling takes care of the request
and no further processing is needed

This component-based model allows easy combination of simple modules
into a powerful super-module (as in super-man)
- case study: a Swiki
  - Swiki = as parent
    - bare bones (search is outsourced)
  - FileServer
    - mini-FTP
    - provides uploads
  - SearchEngine
    - search the index and return a results page
    - using the parent's index
  - SpellChecking

Each module optionally supports persistence.

Big TODO list
- make pluggable:
  - formatters - HTML, VRML, email, etc.
  - templates - regular, rendering, cached, etc.
  - spellers - to select languages, professions
  - externalizers/persistence - to choose among formats - XML, RefStream, etc.
!
]style[(8 1610)bcblue;f2,f1!

!Comanche class reorganize!
('initialize-release' initialize)
('accessing' serverOnPort: servers)
('management' addModule:toServerOnPort: defaultPriority httpdStartOnPort: httpdStartOnPort:package: httpdStopOnPort: startOnPort:package:)
('preferences' allowUploads preferences)
!


!Comanche class methodsFor: 'initialize-release' stamp: 'bolot 9/11/1999 15:32'!
initialize
	Servers _ Dictionary new.
	Queues _ Dictionary new.
	ComanchePreferences _ Dictionary new.
	ComanchePreferences at: #allowUploads put: true! !

!Comanche class methodsFor: 'initialize-release' stamp: 'bolot 9/11/1999 15:34'!
serverName
	^'Comanche ', self version! !

!Comanche class methodsFor: 'initialize-release' stamp: 'bolot 9/11/1999 15:33'!
version
	^'1.0.1 beta 3'! !

!Comanche class methodsFor: 'accessing' stamp: 'bolot 5/14/1999 23:32'!
serverOnPort: n
	^Servers at: n ifAbsent: []! !

!Comanche class methodsFor: 'accessing' stamp: 'bolot 5/15/1999 14:18'!
servers
	^Servers! !

!Comanche class methodsFor: 'management' stamp: 'bolot 5/20/1999 01:43'!
addModule: module toServerOnPort: n
	(Servers includesKey: n) ifFalse: [self error: 'No server on port ', n asString].

	"(Servers at: n) registerModule: module"! !

!Comanche class methodsFor: 'management' stamp: 'bolot 7/16/1999 11:49'!
defaultPriority
	^Processor userInterruptPriority

	" can also use: "
	" SystemRockBottomPriority _ 1. "
	" SystemBackgroundPriority _ 2. "
	" UserBackgroundPriority _ 3. "
	" UserSchedulingPriority _ 4. "
	" UserInterruptPriority _ 5. "
	" LowIOPriority _ 6. "
	" HighIOPriority _ 7. "
	" TimingPriority _ 8 "

	"from: ProcessorScheduler initialize."! !

!Comanche class methodsFor: 'management' stamp: 'bolot 7/16/1999 11:47'!
httpdStartOnPort: n
	" start the server "
	" TODO: provide two versions - bare and loaded "
	" bare will start the server without any modules "
	" loaded will include FileServer module, plus more "

	| queue httpdThread block server |

	((Servers includesKey: n) or: [Queues includesKey: n])
		ifTrue: [(self confirm: 'There''s already a server on port ', n asString, '. Replace?')
					ifFalse: [^nil].
				self httpdStopOnPort: n].

	Socket initializeNetwork.
	block _ [:httpd :socket |
"		httpdThread _ [[httpd startOnSocket: socket] ifError: [:err :rcvr | #ignore] ] newProcess. "
		httpdThread _ [httpd startOnSocket: socket] newProcess.
		httpdThread priority: self defaultPriority.
		httpdThread resume ].
	server _ ComancheModule new initialize.
	queue _ HttpConnectionQueue portNumber: n queueLength: 4
		server: server block: block.
	Servers at: n put: server.
	Queues at: n put: queue.! !

!Comanche class methodsFor: 'management' stamp: 'bolot 9/2/1999 20:55'!
httpdStartOnPort: n package: packageName
	" start the server, use HttpConnectionQueue, a-la PWS "
	" bare will start the server without any modules "
	" loaded will include FileServer module, plus more "
	" this is experimental "
	" bolot 9/2/1999 20:54 "
	" use startOnPort:package: "
	" this version tries to use SharedQueue "

	| queue server socket |

	((Servers includesKey: n) or: [Queues includesKey: n])
		ifTrue: [(self confirm: 'There''s already a server on port ', n asString, '. Replace?')
					ifFalse: [^nil].
				self httpdStopOnPort: n].

	((packageName asString endsWith: 'WebServer') and: [ComancheModule respondsTo: packageName])
		ifFalse: [^self error: 'Invalid package'].

	Socket initializeNetwork.
	server _ ComancheModule perform: packageName.
	queue _ HttpConnectionQueue portNumber: n queueLength: 6.
	Servers at: n put: server.
	Queues at: n put: queue.

	[[true] whileTrue: [
		socket _ queue getConnection.
		server startOnSocket: socket]] forkAt: Processor lowIOPriority! !

!Comanche class methodsFor: 'management' stamp: 'bolot 7/16/1999 11:36'!
httpdStopOnPort: n
	(Servers includesKey: n)
		ifTrue: [Servers removeKey: n].
	(Queues includesKey: n)
		ifTrue: [(Queues at: n) destroy. Queues removeKey: n].
! !

!Comanche class methodsFor: 'management' stamp: 'bolot 7/16/1999 15:53'!
startOnPort: n package: packageName
	" start the server "
	" TODO: provide two versions - bare and loaded "
	" bare will start the server without any modules "
	" loaded will include FileServer module, plus more "

	| queue httpdThread block server |

	((Servers includesKey: n) or: [Queues includesKey: n])
		ifTrue: [(self confirm: 'There''s already a server on port ', n asString, '. Replace?')
					ifFalse: [^nil].
				self httpdStopOnPort: n].

	((packageName asString endsWith: 'WebServer') and: [ComancheModule respondsTo: packageName])
		ifFalse: [^self error: 'Invalid package'].

	Socket initializeNetwork.
	block _ [:httpd :socket |
"		httpdThread _ [[httpd startOnSocket: socket] ifError: [:err :rcvr | #ignore] ] newProcess. "
		httpdThread _ [httpd startOnSocket: socket] newProcess.
		httpdThread priority: self defaultPriority.
		httpdThread resume ].
	server _ ComancheModule perform: packageName.
	queue _ HttpConnectionQueue portNumber: n queueLength: 4
		server: server block: block.
	Servers at: n put: server.
	Queues at: n put: queue.! !

!Comanche class methodsFor: 'preferences' stamp: 'bolot 9/11/1999 15:35'!
allowUploads
	^ComanchePreferences at: #allowUploads ifAbsent: [false]! !

!Comanche class methodsFor: 'preferences' stamp: 'bolot 9/11/1999 15:33'!
preferences
	^ComanchePreferences! !


!ComancheModule commentStamp: '<historical>' prior: 0!
ComancheModule

a module is a component that can be part of another module

each module can have peer modules and children modules

peer modules can be shared among modules
- for things like authorization, accounting, logging
- they can influence the way a module processes the request
  - e.g., authorization module returns an error, thus terminate

children modules provide value added services
- e.g., formatting, spell checking!
]style[(14 417)f2cblue;b,f1!

!ComancheModule reorganize!
('accessing' directory modules name)
('private' privName: privTempDirNamed: privWorkDirNamed: tempDir)
('initialization' initialize logToStream:)
('processing' filter: handleError:forReceiver: logRequest: process: processAfterModules: processBeforeModules: processModules: startOnSocket:)
('permissions' checkAuthorization: isAuthorized:toDo:)
('persistence' readFrom: writeOn:)
('http stuff' httpVersion)
('debugging' printDebugOn:)
!


!ComancheModule methodsFor: 'accessing' stamp: 'bolot 7/16/1999 11:59'!
directory
	^workDir! !

!ComancheModule methodsFor: 'accessing' stamp: 'bolot 5/20/1999 00:09'!
modules
	^modules! !

!ComancheModule methodsFor: 'accessing' stamp: 'bolot 5/16/1999 15:58'!
name
	^name! !

!ComancheModule methodsFor: 'private' stamp: 'bolot 5/16/1999 15:58'!
privName: str
	name _ str! !

!ComancheModule methodsFor: 'private' stamp: 'bolot 5/19/1999 00:02'!
privTempDirNamed: path
	tempDir _ FileDirectory on: path! !

!ComancheModule methodsFor: 'private' stamp: 'bolot 7/16/1999 11:59'!
privWorkDirNamed: path
	workDir _ FileDirectory on: path! !

!ComancheModule methodsFor: 'private' stamp: 'bolot 5/19/1999 00:02'!
tempDir
	^tempDir! !

!ComancheModule methodsFor: 'initialization' stamp: 'bolot 8/18/1999 17:24'!
initialize
	modules _ OrderedCollection new.
	logfile _ DummyStream on: ''.! !

!ComancheModule methodsFor: 'initialization' stamp: 'bolot 9/16/1999 19:42'!
logToStream: stream
	logfile _ stream.
	logfile
		ifNotNil: [logfile setToEnd]
		ifNil: [logfile _ DummyStream on: '']! !

!ComancheModule methodsFor: 'processing' stamp: 'bolot 5/21/1999 02:02'!
filter: request
	" determine if this module handles request "
	^request! !

!ComancheModule methodsFor: 'processing' stamp: 'bolot 5/18/1999 19:55'!
handleError: err forReceiver: rcvr
	" Return value "
	" nil = error not handled "
	" smth else = error handled, returning result "
	" -- e.g., return a loggable description "

	^nil! !

!ComancheModule methodsFor: 'processing' stamp: 'bolot 8/18/1999 17:10'!
logRequest: request
	logfile nextPutAll: (String streamContents: [:stream |
		request printLogOn: stream])! !

!ComancheModule methodsFor: 'processing' stamp: 'bolot 8/18/1999 17:11'!
process: rawRequest
	" standard module processing "
	" PRE: rawRequest is-a HttpRequest "
	" POST: returns HttpRequest "
	| request |
" DEBUG "
	"self class name asString displayAt: 10@10."

	" check if I handle this rawRequest "
	(request _ self filter: rawRequest)
		ifNil: [^rawRequest].

" DEBUG "
	"request asString displayAt: 10@50."
	"request method asString displayAt: 10@70."

	request done ifTrue: [^request].
	request _ self processBeforeModules: request.
	request done ifTrue: [^request].
	request _ self processModules: request.
	request done ifTrue: [^request].
	request _ self processAfterModules: request.
	self logRequest: request.

" TODO: Processor yield - to let others run "

	^request! !

!ComancheModule methodsFor: 'processing' stamp: 'bolot 7/14/1999 17:15'!
processAfterModules: request
	^request! !

!ComancheModule methodsFor: 'processing' stamp: 'bolot 7/14/1999 17:15'!
processBeforeModules: request
	^request! !

!ComancheModule methodsFor: 'processing' stamp: 'bolot 7/16/1999 11:41'!
processModules: request
	| aReq |
	aReq _ request.
	modules do: [:m | aReq _ m process: aReq. aReq done ifTrue: [^aReq]].
	^aReq! !

!ComancheModule methodsFor: 'processing' stamp: 'bolot 9/9/1999 14:28'!
startOnSocket: s
	" process the request on the socket "
	" this method is launched in a separate thread for each request "
	| req |
	Time millisecondClockValue printString displayAt: 10@10.
	(req _ HttpRequest on: s)
		ifNil: [^self].
	Time millisecondClockValue printString displayAt: 10@30.
	self process: req.
	req destroy.
	Time millisecondClockValue printString displayAt: 10@50.! !

!ComancheModule methodsFor: 'permissions' stamp: 'bolot 5/16/1999 17:16'!
checkAuthorization: request
	" return the access control "
	" including user (if any), permissions "
	^true! !

!ComancheModule methodsFor: 'permissions' stamp: 'bolot 5/15/1999 16:38'!
isAuthorized: request toDo: action
	" check authorization for a particular action "
	^false! !

!ComancheModule methodsFor: 'persistence' stamp: 'bolot 5/20/1999 01:18'!
readFrom: aStream
	" implement persistence "! !

!ComancheModule methodsFor: 'persistence' stamp: 'bolot 5/20/1999 01:18'!
writeOn: aStream
	" implement persistence "! !

!ComancheModule methodsFor: 'http stuff' stamp: 'bolot 7/14/1999 17:09'!
httpVersion
	" version of HTTP supported "

	^'HTTP/1.1'! !

!ComancheModule methodsFor: 'debugging' stamp: 'bolot 9/11/1999 12:45'!
printDebugOn: stream
	| specialVars |
	specialVars _ #(name parent modules).

	self class name printOn: stream.
	stream nextPutAll: ' ''', self name, ''' ('.

	(self class allInstVarNames select: [:string | (specialVars includes: string) not])
		do: [:string | stream nextPutAll: string, '=', (self instVarNamed: string) printString]
		separatedBy: [stream nextPutAll: '; '].
	stream nextPutAll: ')'.

	stream nextPutAll: '; modules=('.
	modules do: [:m | m printDebugOn: stream]
		separatedBy: [stream nextPutAll: '; '].

	stream nextPutAll: ')'.! !


!AccessControlModule commentStamp: 'bolot 9/16/1999 19:44' prior: 0!
AccessControlModule
- implements access control lists (not yet!!)
- to be effective, must be used before data serving modules
  (say right after DomainFilterModule)
- realm is name (e.g. AccessControlModule newModuleNamed: 'squeak/myswiki')!

!AccessControlModule methodsFor: 'processing' stamp: 'bolot 8/18/1999 18:56'!
filter: request
	"always return a request"
	"but also add an operation(s) to it"

	"request privOperation: 'somehow decoded from request'."
	"e.g.: post and multipart => multipartPost"
	"post and form => write/edit/etc."
	"otherwise, just nil <=> read"

	^request! !

!AccessControlModule methodsFor: 'processing' stamp: 'bolot 8/9/1999 21:47'!
initialize
	super initialize.
	accessControlList _ AccessControlList new initialize! !

!AccessControlModule methodsFor: 'processing' stamp: 'bolot 8/9/1999 21:47'!
privAccessControlList: newList
	accessControlList _ newList! !

!AccessControlModule methodsFor: 'processing' stamp: 'bolot 9/11/1999 16:45'!
process: rawRequest
	" check if request action and user are allowed by accessControlList "
	| request |
	request _ self filter: rawRequest.
	(accessControlList is: request user authorizedToDo: request operation)
		ifFalse: [request unauthorizedFor: name].
	^request! !


!ActiveSqueakModule commentStamp: 'bolot 8/12/1999 01:34' prior: 0!
ActiveSqueakModule
functionality similar to ASP, ColdFusion, and PHP

TODO: come up with file extension convension
currently using .phd (huh, go figure!!)

rule 1: all code inside <? and ?> is copied as-is, and compiled
rule 2: all code outside is output using page stream nextPutAll:


<body>hello
<? stream nextPutAll: Time now printString ?>
bye</body>

is translated into:

stream nextPutAll: '<body>hello'.
stream nextPutAll: Time now printString.
stream nextPutAll: 'bye</body>'.
!

!ActiveSqueakModule methodsFor: 'processing' stamp: 'bolot 8/12/1999 01:27'!
compileFileNamed: filename
	| sourceCode compiler methodNode |

	(sourceCode _ self translateFileNamed: filename)
		ifNil: [^nil].

	sourceCode reset.
	compiler _ Compiler new.
	compiler from: sourceCode class: ActiveSqueakPage context: nil notifying: nil.
	methodNode _ compiler translate: sourceCode noPattern: true ifFail: [].
	^methodNode generate: #(0 0 0 0)! !

!ActiveSqueakModule methodsFor: 'processing' stamp: 'bolot 8/11/1999 21:58'!
filter: rawRequest
	"TODO: come up with ASM file extension"
	| request filename |
	(rawRequest url endsWith: '.phd')
		ifFalse: [^nil].

	request _ FileServerRequest fromRequest: rawRequest.
	filename _ (FileUrl absoluteFromText: rawRequest url) pathForFile.
	filename _ filename copyFrom: self name size + 1 to: filename size.
	filename _ self directory pathName, filename.
	request fileName: filename.

	^request! !

!ActiveSqueakModule methodsFor: 'processing' stamp: 'bolot 9/4/1999 18:52'!
processAfterModules: request
	| page executable value tempSelector |
	"TODO: cache compiled pages"

	executable _ self compileFileNamed: request filename.
	executable ifNil: [^request notFound].

	request responseHeaderAt: 'Content-type' put: 'text/html'.
	request success.

	page _ ActiveSqueakPage new privStream: request stream.
	tempSelector _ ('aspDoIt', (Time millisecondClockValue) asString) asSymbol.
	ActiveSqueakPage addSelector: tempSelector withMethod: executable.
	value _ page perform: tempSelector.
	ActiveSqueakPage removeSelectorSimply: tempSelector.

	request stopResponse.

	^request! !

!ActiveSqueakModule methodsFor: 'processing' stamp: 'bolot 8/12/1999 01:26'!
translateFileNamed: filename
	"translate a .phd file into a doIt-able Smalltalk code"
	"text <?code?> text2 -> page stream nextPutAll: text. code. page stream nextPutAll: text2"
	"TODO: account for possibility of '?>' being in the code"
	"-- for now, work-around is to do ('?', '>')"
	| file stream text code |
	(workDir fileExists: filename)
		ifFalse: [^nil].
	file _ ReadStream on: (workDir readOnlyFileNamed: filename) contentsOfEntireFile.
	stream _ ReadWriteStream on: String new.

	[file atEnd]
	whileFalse: [
		text _ (file upToAll: '<?').
		stream nextPutAll: 'stream nextPutAll: ', text printString, '.'; cr.
		"file next; next." "skip '<?'"
		code _ file upToAll: '?>'.
		stream nextPutAll: code, '.'; cr.
		"file next; next." "skip '?>'"].

	^stream! !


!ComancheModule class reorganize!
('instance creation' defaultDirectory defaultTempDirectory newModuleNamed: newModuleNamed:workDir:tempDir:)
('web server packages' basicWebServer protectedWebServer sqiniWebServer standardWebServer)
!


!ComancheModule class methodsFor: 'instance creation' stamp: 'bolot 8/10/1999 15:35'!
defaultDirectory
	| delim |
	delim _ FileDirectory slash.
	^FileDirectory default pathName , delim , 'www', delim! !

!ComancheModule class methodsFor: 'instance creation' stamp: 'bolot 8/11/1999 22:38'!
defaultTempDirectory
	| delim |
	delim _ FileDirectory slash.
	^FileDirectory default pathName , delim , 'temp', delim! !

!ComancheModule class methodsFor: 'instance creation' stamp: 'bolot 8/11/1999 22:38'!
newModuleNamed: str
	^self newModuleNamed: str
		workDir: self defaultDirectory
		tempDir: self defaultTempDirectory! !

!ComancheModule class methodsFor: 'instance creation' stamp: 'bolot 7/16/1999 12:01'!
newModuleNamed: str workDir: workDirPath tempDir: tempDirPath
	^self new initialize;
		privName: str;
		privWorkDirNamed: workDirPath;
		privTempDirNamed: tempDirPath! !

!ComancheModule class methodsFor: 'web server packages' stamp: 'bolot 9/16/1999 19:40'!
basicWebServer
	" create a set of modules that collectively provide
	  a basic set of web services "

	| webServer fileServer uploadServer logFile |
	logFile _ FileStream fileNamed: 'comanche.log'.
	webServer _ self newModuleNamed: 'comanche'.
" add file server - aka plain vanilla web server "
	fileServer _ FileServerModule newModuleNamed: 'www'.
	fileServer logToStream: logFile.
	uploadServer _ MultipartPostModule newModuleNamed: 'upload'.
	webServer modules
		add: uploadServer;
		add: fileServer.

	^webServer! !

!ComancheModule class methodsFor: 'web server packages' stamp: 'bolot 9/11/1999 16:32'!
protectedWebServer
	"a standardWebServer with required log on"

	| webServer authorizer authorizationModule |
	webServer _ self standardWebServer.

	authorizer _ AccessControlList readProtectedFrom: #('guest').
	authorizationModule _ AccessControlModule newModuleNamed: 'squeak/aloha'.
	authorizationModule privAccessControlList: authorizer.
	webServer modules
		addFirst: authorizationModule.

	^webServer! !

!ComancheModule class methodsFor: 'web server packages' stamp: 'bolot 8/12/1999 15:33'!
sqiniWebServer
	" create a set of modules that collectively provide
	  a Sqini server, a-la Jini "

	| webServer fileServer uploadServer |
	webServer _ self newModuleNamed: 'comanche'.
	"active scripting server"
	webServer modules add: (ActiveSqueakModule newModuleNamed: 'ASM').

	"Sqini server"
	webServer modules add: (ObjectServerModule newModuleNamed: 'SQINI').

	"file server - aka plain vanilla web server "
	fileServer _ FileServerModule newModuleNamed: 'www'.
	uploadServer _ MultipartPostModule newModuleNamed: 'upload'.
	fileServer modules add: uploadServer.
	webServer modules add: fileServer.

" add swiki server "
" add admin server "

	^webServer! !

!ComancheModule class methodsFor: 'web server packages' stamp: 'bolot 9/16/1999 19:41'!
standardWebServer
	" create a set of modules that collectively provide
	  a standard set of web services "

	| webServer fileServer uploadServer logFile |
	logFile _ FileStream fileNamed: ('comanche.', (Date today yyyymmdd), '.log').
	webServer _ self newModuleNamed: 'comanche'.
	"active scripting server"

	"file server - aka plain vanilla web server "
	fileServer _ FileServerModule newModuleNamed: 'www'.
	fileServer logToStream: logFile.
	uploadServer _ MultipartPostModule newModuleNamed: 'upload'.

	webServer modules
		add: (ActiveSqueakModule newModuleNamed: 'ASM');
		add: uploadServer;
		add: fileServer.

" add swiki server "
" add admin server "

	^webServer! !


!Date methodsFor: 'printing' stamp: 'bolot 8/18/1999 17:22'!
yyyymmdd
	"no delimiters"

	"Date today yyyymmdd"

	^ self printFormat: #(3 2 1 $- 1 1 2)! !


!DomainFilterModule commentStamp: '<historical>' prior: 0!
DomainFilterModule
	allow: ip-pattern, domain-pattern
	deny: ip-pattern, domain-pattern

- to be effective, must be used before any modules
  that write back to the client

- as other service modules, over-rides process:
  thus disabling any use of submodules!

!DomainFilterModule methodsFor: 'processing' stamp: 'bolot 7/16/1999 12:48'!
allow: domainPattern
	(allowedDomains includes: domainPattern)
		ifFalse: [allowedDomains add: domainPattern]! !

!DomainFilterModule methodsFor: 'processing' stamp: 'bolot 7/16/1999 12:48'!
deny: domainPattern
	(deniedDomains includes: domainPattern)
		ifFalse: [deniedDomains add: domainPattern]! !

!DomainFilterModule methodsFor: 'processing' stamp: 'bolot 7/16/1999 13:33'!
process: request
	deniedDomains contains: [:domainPattern |
		(domainPattern match: request remoteAddress)
			ifTrue: [^request abort]].
	^request! !


!FileDirectory methodsFor: 'printing' stamp: 'bolot 9/11/1999 15:18'!
printIndexOn: aStream urlPrefix: aRawUrlPrefix
	"print the index of files in an HTML table"
	| name size prefix mDate parentUrl aUrlPrefix |
	(aUrlPrefix _ aRawUrlPrefix) last = $/
		ifTrue: [aUrlPrefix _ aUrlPrefix copyFrom: 1 to: aUrlPrefix size - 1].
	(parentUrl _ (aUrlPrefix copyUpToLast: $/) encodePathForHTTP)
		isEmpty ifTrue: [parentUrl _ aUrlPrefix encodePathForHTTP].

	aStream nextPutAll: '<H1>Index Of ', aUrlPrefix, '</H1>
		<TABLE>
		<TR><TD>Name</TD>  <TD>Last Modified</TD>  <TD>Size</TD></TR>
		<TR><TD><A HREF="', parentUrl,
		'">Parent Directory</A></TD> <TD></TD> <TD></TD></TR>'.

	prefix _ '<TR><TD><A HREF="', aUrlPrefix encodePathForHTTP, '/'.

	" directories "
	self entries do: [:entry |
		(entry at: 4)
			ifTrue: [name _ entry at: 1. mDate _ entry at: 2.
				aStream nextPutAll: prefix, name encodePathForHTTP, '">', name, '</A></TD>
					<TD>', (Time dateAndTimeFromSeconds: mDate) printString, '</TD>
					<TD ALIGN="right">-</TD></TR>'; cr]].
	" files "
	self entries do: [:entry |
		(entry at: 4)
			ifFalse: [name _ entry at: 1. mDate _ entry at: 2. size _ entry at: 5.
				size _ size > 1024
					ifTrue: [(size // 1024) printString, 'k']
					ifFalse: [size printString].
				aStream nextPutAll: prefix, name encodePathForHTTP, '">', name, '</A></TD>
					<TD>', (Time dateAndTimeFromSeconds: mDate) printString, '</TD>
					<TD ALIGN="right">', size, '</TD></TR>'; cr]].
	aStream nextPutAll: '</TABLE>'! !


!FileServerModule methodsFor: 'processing' stamp: 'bolot 8/11/1999 19:17'!
filter: rawRequest
	| request filename |
	(rawRequest url beginsWith: '/', self name)
		ifFalse: [^nil].

	request _ FileServerRequest fromRequest: rawRequest.
	filename _ (FileUrl absoluteFromText: rawRequest url) pathForFile.
	filename _ filename copyFrom: self name size + 1 to: filename size.
	filename _ self directory pathName, filename.
	request fileName: filename.

	^request! !

!FileServerModule methodsFor: 'processing' stamp: 'bolot 9/15/1999 14:14'!
process: rawRequest
	| file uploads filename oldFilename newFilename uploadDir fileType request |

	(request _ self filter: rawRequest)
		ifNil: [^rawRequest].

	filename _ request filename.
	(workDir fileExists: filename)
		ifTrue: [fileType _ #file. uploadDir _ (FileDirectory dirPathFor: filename), FileDirectory slash]
		ifFalse:
			[filename last = FileDirectory pathNameDelimiter
				ifTrue: [filename _ filename copyFrom: 1 to: filename size - 1].
			(workDir directoryExists: filename)
				ifTrue: [fileType _ #directory. uploadDir _ filename, FileDirectory slash]
				ifFalse: [fileType _ #notFound. uploadDir _ workDir pathName]].

	"process uploads"
	uploads _ request postFields select: [:field |
		field isKindOf: MIMEDocument].

	uploads do: [:doc |
		oldFilename _ doc url pathForFile.
		newFilename _ uploadDir,
			doc url path last.
		[tempDir rename: oldFilename toBe: newFilename]
		ifError: [:err :rcvr | "try to copy and delete"
			tempDir copyFileNamed: oldFilename toFileNamed: newFilename.
			tempDir deleteFileNamed: oldFilename]].

	fileType caseOf:
		{ [#file]->[file _ workDir readOnlyFileNamed: filename.
			request serveFile: file.
			file close.
			request stopProcessing; stopResponse].
		[#directory]->[file _ workDir directoryNamed: filename.
			request directoryIndex: file withUploadForm: Comanche allowUploads.
			request stopProcessing; stopResponse]
	} otherwise: [" not found "].

	self logRequest: request.

	^request
	"TODO: not found handling"! !


!HttpConnectionQueue methodsFor: 'private' stamp: 'bolot 5/14/1999 23:39'!
block: b
	block _ b! !

!HttpConnectionQueue methodsFor: 'private' stamp: 'bolot 9/2/1999 17:24'!
initPortNumber: anInteger queueLength: queueLength
	"Private!! Initialize the receiver to listen on the given port number. Up to queueLength connections will be queued."

	portNumber _ anInteger.
	maxQueueLength _ queueLength.
	connections _ SharedQueue new: maxQueueLength.
	accessSema _ Semaphore forMutualExclusion.
	socket _ nil.
	process _ [self listenLoop] newProcess.
	process priority: Processor highIOPriority.
	process resume.
! !

!HttpConnectionQueue methodsFor: 'private' stamp: 'bolot 9/2/1999 17:33'!
listenLoop
	"see comment on ConnectionQueue>>listenLoop"

	| listener |
	"1 == 1 ifTrue: [^self oldStyleListenLoop]."
	listener _ HTTPSocket newTCP.
	"We'll accept four simultanous connections at the same time"
	listener listenOn: portNumber backlogSize: 4.
	listener isValid ifFalse: [^self oldStyleListenLoop].
	[true] whileTrue: [
		socket _ listener waitForAcceptUntil: (Socket deadlineSecs: 10).
		socket ifNotNil:
			[(server notNil and: [block notNil])
				ifTrue: [block value: server value: socket]
				ifFalse: [connections nextPut: socket].
			socket _ nil].
		self pruneStaleConnections].! !

!HttpConnectionQueue methodsFor: 'private' stamp: 'bolot 9/2/1999 17:33'!
oldStyleListenLoop
	"see comment on ConnectionQueue>>oldStyleListenLoop"

	[true] whileTrue: [
		((socket == nil) and: [connections size < maxQueueLength]) ifTrue: [
			"try to create a new socket for listening"
			socket _ HTTPSocket createIfFail: [nil]].

		socket == nil
			ifTrue: [(Delay forMilliseconds: 100) wait]
			ifFalse: [
				socket isUnconnected ifTrue: [socket listenOn: portNumber].
				socket waitForConnectionUntil: (Socket deadlineSecs: 10).
				socket isConnected
					ifTrue: [  "connection established"
						(server notNil and: [block notNil])
							ifTrue: [block value: server value: socket]
							ifFalse: [connections nextPut: socket].
						socket _ nil]
					ifFalse: [
						socket isWaitingForConnection
							ifFalse: [socket destroy. socket _ nil]]].  "broken socket; start over"
		self pruneStaleConnections].
! !

!HttpConnectionQueue methodsFor: 'private' stamp: 'bolot 9/2/1999 18:19'!
pruneStaleConnections
	"Private!! The client may establish a connection and then disconnect while it is still in the connection queue. This method is called periodically to prune such sockets out of the connection queue and make room for fresh connections."

	| newConnections s |
	1 == 1 ifTrue: [^self].
	newConnections _ SharedQueue new: maxQueueLength.
	[connections peek isNil not]
		whileTrue: [s _ connections next.
			s isUnconnected
				ifTrue: [s destroy]
				ifFalse: [newConnections nextPut: s]].
	connections _ newConnections! !

!HttpConnectionQueue methodsFor: 'private' stamp: 'bolot 5/14/1999 23:39'!
server: s
	server _ s! !

!HttpConnectionQueue methodsFor: 'public' stamp: 'bolot 9/2/1999 17:25'!
destroy
	"Terminate the listener process and destroy all sockets in my possesion."

	process ifNotNil: [
		process terminate.
		process _ nil].
	socket ifNotNil: [
		socket destroy.
		socket _ nil].
	[connections isEmpty] whileFalse: [connections next destroy].
	connections _ SharedQueue new: maxQueueLength.
! !

!HttpConnectionQueue methodsFor: 'public' stamp: 'bolot 9/2/1999 18:20'!
getConnection
	| s |
	"Return a connected socket, block until connection has been established."

	[s _ connections next.
	s isUnconnected] whileTrue.
	^s! !


!HttpConnectionQueue class methodsFor: 'instance creation' stamp: 'bolot 5/14/1999 23:36'!
portNumber: anInteger queueLength: queueLength server: server block: block

	^ self new initPortNumber: anInteger queueLength: queueLength;
		server: server; block: block
! !


!HttpRequest commentStamp: 'bolot 8/18/1999 13:19' prior: 0!
HttpRequest
	basic request

supports:
- authentication (basic)
- logging (printLogOn: printFullLogOn:)
- status!

!HttpRequest reorganize!
('initialization' readHeader stream:)
('accessing' contentLength contentType cookies cookiesRaw destroy getFields header method multipartFormDataBoundary operation postFields protocol remoteAddress responseHeader status stream url)
('converting' printHtmlOn: printHtmlString printOn:)
('logging' printFullLogOn: printLogOn:)
('private' privCookies: privGetFields: privOperation: privPostFields: privResponseHeader: privStatus: privStream: privUrl:)
('authentication' user)
('response' done redirectTo: responseHeaderAt:put: sendHeader sendHeaderWithStatus: stopProcessing stopResponse success)
('serving' serveHtml: serveStream:contentType:contentLength:)
('errors' badRequest unauthorizedFor:)
!


!HttpRequest methodsFor: 'initialization' stamp: 'bolot 9/11/1999 13:11'!
readHeader
	| i getQuery postQuery |
	status _ HttpStatus new.
	status at: #timestamp put: Time totalSeconds.
	responseHeader _ Dictionary new.
	url _ stream status at: #url ifAbsent: [''].

	" parse cgi fields in the url, if any "
	(i _ url indexOf: $?) > 0
		ifTrue: [getQuery _ url copyFrom: i+1 to: url size.
			url _ url copyFrom: 1 to: i-1.
			getFields _ self class decodeUrlEncodedForm: getQuery]
		ifFalse: [getFields _ Dictionary new].
	url unescapePercents.

	" parse cgi fields in the body of request, if it's standard form data "
	(self method = 'POST' and: [self contentType = MIMEDocument contentTypeFormData])
		ifTrue: [postQuery _ stream upToEnd withBlanksTrimmed.
			postFields _ self class decodeUrlEncodedForm: postQuery]
		ifFalse: [postFields _ Dictionary new "to simplify access to post fields dictionary"]! !

!HttpRequest methodsFor: 'initialization' stamp: 'bolot 5/6/1999 20:17'!
stream: s
	stream _ s! !

!HttpRequest methodsFor: 'accessing' stamp: 'bolot 8/18/1999 15:43'!
contentLength
	^(self header at: 'content-length' ifAbsent: [0]) asNumber! !

!HttpRequest methodsFor: 'accessing' stamp: 'bolot 8/20/1999 10:13'!
contentType
	| i contentType |
	contentType _ self header at: 'content-type' ifAbsent: [].
	contentType ifNotNil: [i _ contentType indexOf: $;. "get rid of charset field"
		i > 0 ifTrue: [contentType _ contentType asLowercase copyFrom: 1 to: i-1]].
	^contentType! !

!HttpRequest methodsFor: 'accessing' stamp: 'bolot 8/18/1999 16:53'!
cookies
	^cookies isNil
		ifFalse: [cookies]
		ifTrue: [cookies _ self class decodeUrlEncodedForm: (self header at: 'cookies' ifAbsent: [''])
					fieldDelimiters: ' ;']! !

!HttpRequest methodsFor: 'accessing' stamp: 'bolot 8/18/1999 16:54'!
cookiesRaw
	^cookies! !

!HttpRequest methodsFor: 'accessing' stamp: 'bolot 5/15/1999 16:33'!
destroy
	stream close.
	stream _ nil! !

!HttpRequest methodsFor: 'accessing' stamp: 'bolot 5/16/1999 17:26'!
getFields
	^getFields! !

!HttpRequest methodsFor: 'accessing' stamp: 'bolot 8/18/1999 15:42'!
header
	^stream header! !

!HttpRequest methodsFor: 'accessing' stamp: 'bolot 8/18/1999 15:54'!
method
	^stream status at: #method ifAbsent: ['GET']! !

!HttpRequest methodsFor: 'accessing' stamp: 'bolot 8/18/1999 15:43'!
multipartFormDataBoundary
	| str idx |
	str _ self header at: 'content-type' ifAbsent: [''].
	(str asLowercase beginsWith: 'multipart/form-data') ifFalse: [^nil].
	idx _ str indexOf: $=. " Content-Type: multipart/form-data; boundary=----- "
	^(str copyFrom: idx + 1 to: str size)! !

!HttpRequest methodsFor: 'accessing' stamp: 'bolot 8/18/1999 18:37'!
operation
	^operation! !

!HttpRequest methodsFor: 'accessing' stamp: 'bolot 5/16/1999 17:26'!
postFields
	^postFields! !

!HttpRequest methodsFor: 'accessing' stamp: 'bolot 8/18/1999 15:51'!
protocol
	^stream status at: #protocol ifAbsent: ['HTTP/1.0']! !

!HttpRequest methodsFor: 'accessing' stamp: 'bolot 5/6/1999 20:42'!
remoteAddress
	^stream remoteAddress! !

!HttpRequest methodsFor: 'accessing' stamp: 'bolot 5/18/1999 19:57'!
responseHeader
	^responseHeader! !

!HttpRequest methodsFor: 'accessing' stamp: 'bolot 8/18/1999 14:31'!
status
	^status! !

!HttpRequest methodsFor: 'accessing' stamp: 'bolot 5/6/1999 20:16'!
stream
	^stream! !

!HttpRequest methodsFor: 'accessing' stamp: 'bolot 5/16/1999 16:58'!
url
	^url! !

!HttpRequest methodsFor: 'converting' stamp: 'bolot 8/18/1999 16:55'!
printHtmlOn: printStream
	printStream nextPutAll: '<B>', self class name, '</B><UL>'; cr;
		nextPutAll: '<LI><B>URL</B>=', url asString; cr;
		nextPutAll: '<LI><B>protocol</B>=', self protocol asString; cr.

	self header isEmpty not
		ifTrue: [printStream nextPutAll: '<LI><B>Header</B><UL>'; cr.
			self header associationsDo: [:a | printStream nextPutAll: '<LI><B>', a key, '</B>=', a value; cr].
			printStream nextPutAll: '</UL>'; cr].

	(getFields notNil and: [getFields isEmpty not])
		ifTrue: [printStream nextPutAll: '<LI><B>getFields</B><UL>'; cr.
			getFields associationsDo: [:a | printStream nextPutAll: '<LI><B>', a key, '</B>=', a value; cr].
			printStream nextPutAll: '</UL>'; cr].

	(postFields notNil and: [postFields isEmpty not])
		ifTrue: [printStream nextPutAll: '<LI><B>postFields</B><UL>'; cr.
			postFields associationsDo: [:a | printStream nextPutAll: '<LI><B>', a key, '</B>=', a value; cr].
			printStream nextPutAll: '</UL>'; cr].

	printStream
		nextPutAll: '</UL>'; cr.! !

!HttpRequest methodsFor: 'converting' stamp: 'bolot 5/16/1999 14:48'!
printHtmlString
	^String streamContents: [:tempStream | self printHtmlOn: tempStream]
! !

!HttpRequest methodsFor: 'converting' stamp: 'bolot 8/18/1999 16:55'!
printOn: printStream
	printStream nextPutAll: self class name;
		nextPutAll: ' (URL=', url asString;
		nextPutAll: '; protocol=', self protocol asString;
		nextPutAll: '; header=', self header asString;
		nextPutAll: '; getFields=', getFields asString;
		nextPutAll: '; postFields=', postFields asString;
		nextPutAll: ')'! !

!HttpRequest methodsFor: 'logging' stamp: 'bolot 9/15/1999 15:06'!
printFullLogOn: printStream
	"remotehost rfc931 authuser [date] 'request' status bytes"
	printStream nextPutAll:
	(String streamContents: [:writeStream |
		writeStream nextPutAll: (NetNameResolver stringFromAddress: self remoteAddress); tab;
			nextPutAll: '-	-'; tab;
			nextPutAll: (status at: #timestamp ifAbsent: []) asString; tab;
			nextPutAll: url asString; tab;
			nextPutAll: (status at: #httpResponseStatus ifAbsent:[]) asString; tab;
			nextPutAll: stream outDataCount asString; cr; tab;
			nextPutAll: getFields asString; cr; tab;
			nextPutAll: postFields asString; cr])! !

!HttpRequest methodsFor: 'logging' stamp: 'bolot 9/15/1999 15:05'!
printLogOn: printStream
	"remotehost rfc931 authuser [date] 'request' status bytes"
	printStream nextPutAll:
	(String streamContents: [:writeStream |
		writeStream nextPutAll: (NetNameResolver stringFromAddress: self remoteAddress); tab;
			nextPutAll: '-	-'; tab;
			nextPutAll: (status at: #timestamp ifAbsent: []) asString; tab;
			nextPutAll: url asString; tab;
			nextPutAll: (status at: #httpResponseStatus ifAbsent:[]) asString; tab;
			nextPutAll: stream outDataCount asString; cr])! !

!HttpRequest methodsFor: 'private' stamp: 'bolot 5/18/1999 20:15'!
privCookies: dict
	cookies _ dict! !

!HttpRequest methodsFor: 'private' stamp: 'bolot 5/16/1999 17:22'!
privGetFields: g
	getFields _ g! !

!HttpRequest methodsFor: 'private' stamp: 'bolot 8/18/1999 18:37'!
privOperation: op
	operation _ op! !

!HttpRequest methodsFor: 'private' stamp: 'bolot 5/16/1999 17:22'!
privPostFields: p
	postFields _ p! !

!HttpRequest methodsFor: 'private' stamp: 'bolot 5/18/1999 19:57'!
privResponseHeader: dict
	responseHeader _ dict! !

!HttpRequest methodsFor: 'private' stamp: 'bolot 8/18/1999 14:31'!
privStatus: statusDict
	status _ statusDict! !

!HttpRequest methodsFor: 'private' stamp: 'bolot 5/16/1999 17:23'!
privStream: s
	stream _ s! !

!HttpRequest methodsFor: 'private' stamp: 'bolot 5/16/1999 17:22'!
privUrl: u
	url _ u! !

!HttpRequest methodsFor: 'authentication' stamp: 'bolot 9/11/1999 16:44'!
user
	"currently, only basic authentication is supported"
	| userID i |
	userID _ self header at: 'authorization' ifAbsent: [^nil].
	(userID notNil and: [(i _ userID findString: 'Basic ') > 0])
		ifTrue: [userID _ userID copyFrom: i+6 to: userID size]
		ifFalse: [userID _ nil].
	^userID! !

!HttpRequest methodsFor: 'response' stamp: 'bolot 8/18/1999 14:33'!
done
	" done if a module indicates early termination situation "
	" or if there is no more processing necessary "

	^(status at: #responseStatus ifAbsent: []) = #done! !

!HttpRequest methodsFor: 'response' stamp: 'bolot 8/19/1999 19:12'!
redirectTo: aUrl
	self responseHeaderAt: 'Location' put: aUrl;
		responseHeaderAt: 'URI' put: aUrl.
	self sendHeaderWithStatus: #redirect.
	self stopResponse! !

!HttpRequest methodsFor: 'response' stamp: 'bolot 8/11/1999 22:10'!
responseHeaderAt: key put: value
	responseHeader at: key put: value! !

!HttpRequest methodsFor: 'response' stamp: 'bolot 8/11/1999 23:19'!
sendHeader
	responseHeader isEmptyOrNil ifTrue: [stream crlf. ^self].

	responseHeader at: 'server' put: Comanche serverName.

	responseHeader keysAndValuesDo: [:key :value |
		stream nextPutAll: key, ': ', value, String crlf].
	stream crlf! !

!HttpRequest methodsFor: 'response' stamp: 'bolot 8/18/1999 16:56'!
sendHeaderWithStatus: statusCode
	| statusLine |
	statusLine _ HttpStatusCodeDict at: statusCode ifAbsent: [''].
	stream nextPutAll: self protocol, ' ', statusLine; crlf.
	status at: #httpResponseStatus put: statusCode.
	self sendHeader! !

!HttpRequest methodsFor: 'response' stamp: 'bolot 8/18/1999 14:33'!
stopProcessing
	"no more processing should be done"
	status at: #processingStatus put: #done! !

!HttpRequest methodsFor: 'response' stamp: 'bolot 8/18/1999 14:33'!
stopResponse
	"no more response should be sent"
	status at: #responseStatus put: #done! !

!HttpRequest methodsFor: 'response' stamp: 'bolot 8/18/1999 13:06'!
success
	self sendHeaderWithStatus: #success! !

!HttpRequest methodsFor: 'serving' stamp: 'bolot 9/4/1999 19:47'!
serveHtml: htmlStream
	self serveStream: htmlStream contentType: MIMEDocument contentTypeHtml contentLength: htmlStream size asString! !

!HttpRequest methodsFor: 'serving' stamp: 'bolot 9/11/1999 12:15'!
serveStream: htmlStream contentType: contentType contentLength: contentLength
	| chunk chunkSize |

	"Header"
	self responseHeaderAt: 'Content-type' put: contentType;
		responseHeaderAt: 'Content-length' put: contentLength;
		success.
	"Body"
	chunkSize _ 8000. "Socket send buffer size"
	[[htmlStream atEnd not and: [stream isConnected]]
		whileTrue:
			[chunk _ htmlStream next: chunkSize.
			stream nextPutAll: chunk.
			Processor yield]]
				ifError: [:err :rcvr | "ignore"].
	"TODO: error handling, to prevent timeout error if a user cancels download"! !

!HttpRequest methodsFor: 'errors' stamp: 'bolot 8/18/1999 13:05'!
badRequest
	self sendHeaderWithStatus: #badRequest.
	self stopResponse! !

!HttpRequest methodsFor: 'errors' stamp: 'bolot 9/11/1999 16:41'!
unauthorizedFor: realm
	self responseHeaderAt: 'WWW-Authenticate' put: 'Basic realm="',realm,'"'.
	self sendHeaderWithStatus: #unauthorized.
	stream nextPutAll: 'Unauthorized for: ', realm.
	self stopResponse! !


!FileServerRequest methodsFor: 'accessing' stamp: 'bolot 9/11/1999 15:38'!
directoryIndex: dir
	self directoryIndex: dir withUploadForm: false! !

!FileServerRequest methodsFor: 'accessing' stamp: 'bolot 9/11/1999 15:39'!
directoryIndex: dir withUploadForm: showUploadForm
	self responseHeaderAt: 'Content-type' put: 'text/html'.
	self success.

	stream nextPutAll: '<HTML><HEAD>
		<TITLE>Index Of ', url, '</TITLE>
		</HEAD><BODY>'; cr.
	dir printIndexOn: stream urlPrefix: url.

	showUploadForm ifTrue: [self printUploadFormOn: stream].

	stream cr; nextPutAll: '</BODY><HTML>'.! !

!FileServerRequest methodsFor: 'accessing' stamp: 'bolot 5/16/1999 16:30'!
fileName: str
	filename _ str! !

!FileServerRequest methodsFor: 'accessing' stamp: 'bolot 5/16/1999 17:27'!
filename
	^filename! !

!FileServerRequest methodsFor: 'accessing' stamp: 'bolot 9/11/1999 15:30'!
printUploadFormOn: aStream
	aStream nextPutAll: '<FORM ACTION="', url, '" METHOD="POST" ENCTYPE="multipart/form-data">
			<INPUT TYPE="file" NAME="filestuff">
			<INPUT TYPE="submit" VALUE="upload">
		</FORM>'! !

!FileServerRequest methodsFor: 'accessing' stamp: 'bolot 9/4/1999 18:39'!
serveFile: file
	self serveStream: file
		contentType: (MIMEDocument guessTypeFromName: file name)
		contentLength: (file size asString)! !


!HttpRequest class methodsFor: 'instance creation' stamp: 'bolot 9/2/1999 20:57'!
fromRequest: rawRequest
	"create a copy from another request"
	"cannot use #copy because may be a different class"
	rawRequest class == self
		ifTrue: [^rawRequest copy].
	^(self new)
		privResponseHeader: rawRequest responseHeader;
		privUrl: rawRequest url;
		privOperation: rawRequest operation;
		privGetFields: rawRequest getFields;
		privPostFields: rawRequest postFields;
		privCookies: rawRequest cookiesRaw;
		privStream: rawRequest stream;
		privStatus: rawRequest status! !

!HttpRequest class methodsFor: 'instance creation' stamp: 'bolot 9/10/1999 21:09'!
on: socket
	| stream |
	stream _ SocketStream on: socket.
	stream ifNil: [^nil].
	^self onStream: stream! !

!HttpRequest class methodsFor: 'instance creation' stamp: 'bolot 9/2/1999 21:19'!
onStream: stream
	"PRE: stream must be valid"
	^self new stream: stream; readHeader! !

!HttpRequest class methodsFor: 'http stuff' stamp: 'bolot 8/10/1999 22:46'!
decodeUrlEncodedForm: string
	| dict key value start end eqSignPos more |
	dict _ Dictionary new.
	string isEmptyOrNil ifTrue: [^dict].
	more _ true.
	start _ 1.
	[end _ string indexOf: $& startingAt: start.
	end == 0
		ifTrue: [end _ string size. more _ false]
		ifFalse: [end _ end - 1].
	eqSignPos _ string indexOf: $= startingAt: start.
	(eqSignPos > end or: [eqSignPos == 0])
		ifTrue: [key _ (key _ string copyFrom: start to: end) unescapePercents asLowercase.
			value _ '']
		ifFalse: [key _ (key _ string copyFrom: start to: eqSignPos-1) unescapePercents asLowercase.
			value _ (value _ string copyFrom: eqSignPos+1 to: end) unescapePercents].
	dict at: key put: value.
	start _ end + 2.
	more] whileTrue.

	^dict! !

!HttpRequest class methodsFor: 'http stuff' stamp: 'bolot 5/18/1999 20:09'!
decodeUrlEncodedForm: string fieldDelimiters: delims
	| dict tokens i key value |
	dict _ Dictionary new.
	tokens _ string findTokens: delims.
	tokens do: [:t |
		i _ t indexOf: $=.
		key _ (key _ t copyFrom: 1 to: i-1) unescapePercents asLowercase.
		value _ (value _ i < t size
			ifTrue: [ t copyFrom: i+1 to: t size ]
			ifFalse: ['']) unescapePercents.
	(dict includesKey: key)
		ifFalse: [ dict at: key put: value ]
		ifTrue: [
			((dict at: key) isKindOf: String)
				ifTrue: [ dict at: key put: (OrderedCollection with: (dict at: key)) ].
			(dict at: key) add: value]].
	^dict! !

!HttpRequest class methodsFor: 'http stuff' stamp: 'bolot 8/19/1999 19:13'!
defaultHttpStatusCodeDict
	| dict |
	(dict _ Dictionary new)
	at: #success put: '200 OK';
	at: #redirect put: '302 Found';
	at: #unauthorized put: '400 Bad Request';
	at: #unauthorized put: '401 Unauthorized';
	at: #notFound put: '404 Not Found'.
	^dict! !

!HttpRequest class methodsFor: 'http stuff' stamp: 'bolot 8/11/1999 14:48'!
fastParseHeader: string
	| dict key value start end more colonPos fieldDelims statusLine status lastKey keyValueDelim |
	"TODO: support multi-line headers (if line starts with a separator, append to last"
	dict _ Dictionary new.
	string isEmptyOrNil ifTrue: [^dict].
	fieldDelims _ String crlf asCharacterSet.
	keyValueDelim _ $:.
	more _ true.
	start _ 1.
	end _ string indexOfAnyOf: fieldDelims startingAt: start.
	end == 0
		ifTrue: [^dict].
	statusLine _ (string copyFrom: start to: end-1) findTokens: ' '.
	statusLine size = 3
		ifTrue: [(status _ Dictionary new)
			at: #method put: statusLine first;
			at: #url put: statusLine second;
			at: #protocol put: statusLine third].
	start _ string skipDelimiters: String crlf startingAt: end.
	lastKey _ ''.
	[end _ string indexOfAnyOf: fieldDelims startingAt: start.
	end == 0
		ifTrue: [end _ string size. more _ false]
		ifFalse: [end _ end - 1].
	(end >= start and: [start < string size])
		ifTrue: [
			(string at: start) isSeparator
				ifTrue: [dict at: lastKey put: ((dict at: lastKey), (string copyFrom: start to: end))]
				ifFalse: [colonPos _ string indexOf: keyValueDelim startingAt: start.
					(colonPos > end or: [colonPos == 0])
						ifTrue: [key _ (key _ string copyFrom: start to: end) asLowercase.
							value _ '']
						ifFalse: [key _ (key _ string copyFrom: start to: colonPos-1) asLowercase.
							value _ (value _ string copyFrom: colonPos+1 to: end) withBlanksTrimmed]].
			key isEmpty
				ifFalse: [dict at: key put: value.
					lastKey _ key.
					key _ ''].
			start _ string skipDelimiters: String crlf startingAt: end+1].
	more] whileTrue.

	^dict! !

!HttpRequest class methodsFor: 'http stuff' stamp: 'bolot 5/21/1999 03:29'!
parseHeader: string
	"divide into basic lines"
	" based on HTTPSocket header: code "
	| lines foldedLines i statusLine status header |
	lines _ string findTokens: String crlf.
	lines isEmpty ifTrue: [^nil].
	statusLine _ (lines first) findTokens: ' '.
	lines _ lines copyFrom: 2 to: lines size.

	"parse the status (pretty trivial right now)"
	statusLine size = 3
		ifTrue: [(status _ Dictionary new)
			at: #method put: statusLine first;
			at: #url put: statusLine second;
			at: #protocol put: statusLine third].

	"fold lines that start with spaces into the previous line"
	foldedLines _ OrderedCollection new.
	lines do: [ :line |
		line first isSeparator ifTrue: [
			foldedLines at: foldedLines size  put: (foldedLines last, line) ]
		ifFalse: [ foldedLines add: line ] ].

	"make a dictionary mapping headers to header contents"
	header _ Dictionary new.
	foldedLines do: [ :line |
		i _ line indexOf: $:.
		i > 0 ifTrue: [
			header
			at: (line copyFrom: 1 to: i-1) asLowercase 
			put: (line copyFrom: i+1 to: line size) withBlanksTrimmed ] ]..

	^header! !

!HttpRequest class methodsFor: 'http stuff' stamp: 'bolot 8/11/1999 22:17'!
resetHttpStatusCodeDict
	HttpStatusCodeDict _ self defaultHttpStatusCodeDict! !

!HttpRequest class methodsFor: 'initialize-release' stamp: 'bolot 8/11/1999 22:28'!
initialize
	self resetHttpStatusCodeDict! !


!FileServerRequest class methodsFor: 'instance creation' stamp: 'bolot 8/11/1999 13:35'!
for: module fromRequest: rawRequest
	| request filename |
	(rawRequest url beginsWith: '/', module name)
		ifFalse: [^nil].
	rawRequest class == self
		ifTrue: [^rawRequest copy].
	request _ self fromRequest: rawRequest.
	filename _ (FileUrl absoluteFromText: rawRequest url) pathForFile.
	filename _ filename copyFrom: module name size + 1 to: filename size.
	filename _ module directory pathName, filename.
	request fileName: filename.
	^request! !


!HttpStatus commentStamp: 'bolot 8/20/1999 10:09' prior: 0!
HttpStatus

- big TODO!!
- encapsulate all http error codes
- encapsulate progress tracking (header->done, response->header->done, etc.)
!

!HttpStatus methodsFor: 'accessing' stamp: 'bolot 8/18/1999 13:20'!
isSuccess
	^self includesKey: #success! !


!MIMEDocument class reorganize!
('initialize-release' defaultMIMEdatabase extendedMIMEdatabase readMIMEdatabaseFrom:)
('content-types' contentTypeFormData contentTypeHtml contentTypeMultipart contentTypePlainText contentTypeXml guessTypeFromExtension: guessTypeFromName: linkExtension:toType:)
('instance creation' content: contentType:content: contentType:content:url: defaultContentType)
!


!MIMEDocument class methodsFor: 'initialize-release' stamp: 'bolot 5/5/1999 15:44'!
defaultMIMEdatabase
	| d |
	(d _ Dictionary new)
	at: 'html' put: 'text/html';
	at: 'htm' put: 'text/html';
	at: 'xml' put: 'text/xml';
	at: 'txt' put: 'text/plain';
	at: 'c' put: 'text/plain';
	at: 'gif' put: 'image/gif';
	at: 'jpg' put: 'image/jpeg';
	at: 'jpeg' put: 'image/jpeg';
	at: 'xbm' put: 'image/x-xbitmap';
	at: 'mid' put: 'audio/midi';
	at: 'doc' put: 'application/ms-word-document'.
	^d! !

!MIMEDocument class methodsFor: 'initialize-release' stamp: 'bolot 9/9/1999 15:41'!
extendedMIMEdatabase
	| d |
	(d _ self defaultMIMEdatabase)
	at: 'hqx' put: 'application/mac-binhex40';
	at: 'cpt' put: 'application/mac-compactpro';
	at: 'pdf' put: 'application/pdf';
	at: 'ps' put: 'application/postscript';
	at: 'ai' put: 'application/postscript';
	at: 'eps' put: 'application/postscript';
	at: 'rtf' put: 'text/rtf';
	at: 'bin' put: 'application/octet-stream';
	at: 'dms' put: 'application/octet-stream';
	at: 'lha' put: 'application/octet-stream';
	at: 'lzh' put: 'application/octet-stream';
	at: 'exe' put: 'application/octet-stream';
	at: 'class' put: 'application/octet-stream';
	at: 'zip' put: 'application/zip';
	at: 'gtar' put: 'application/x-gtar';
	at: 'swf' put: 'application/x-shockwave-flash';
	at: 'sit' put: 'application/x-stuffit';
	at: 'tar' put: 'application/x-tar';
	at: 'au' put: 'audio/basic';
	at: 'snd' put: 'audio/basic';
	at: 'mid' put: 'audio/midi';
	at: 'midi' put: 'audio/midi';
	at: 'mpga' put: 'audio/mpeg';
	at: 'mp2' put: 'audio/mpeg';
	at: 'mp3' put: 'audio/mpeg';
	at: 'aiff' put: 'audio/x-aiff';
	at: 'aif' put: 'audio/x-aiff';
	at: 'aifc' put: 'audio/x-aiff';
	at: 'rm' put: 'audio/x-pn-realaudio';
	at: 'ram' put: 'audio/x-pn-realaudio';
	at: 'rpm' put: 'audio/x-pn-realaudio-plugin';
	at: 'ra' put: 'audio/x-realaudio';
	at: 'wav' put: 'audio/x-wav';
	at: 'css' put: 'text/css';
	at: 'mpeg' put: 'video/mpeg';
	at: 'mpg' put: 'video/mpeg';
	at: 'mpe' put: 'video/mpeg';
	at: 'qt' put: 'video/quicktime';
	at: 'mov' put: 'video/quicktime';
	at: 'avi' put: 'video/x-msvideo';
	at: 'movie' put: 'video/x-sgi-movie'.
	^d! !

!MIMEDocument class methodsFor: 'initialize-release' stamp: 'bolot 9/9/1999 16:48'!
readMIMEdatabaseFrom: someStream
	| d line tokens stream |
	"type/subtype    extension"
	"white spaces are separators"
	"apache conf file format: mime.types"

	"must normalize line endings"
	stream _ ReadStream on: someStream contentsOfEntireFile withSqueakLineEndings.

	d _ Dictionary new.
	[(line _ stream nextLine) isNil not]
		whileTrue: [tokens _ line findTokens: ' 	'.
			(tokens size = 2 and: [line first ~= $#])
				ifTrue: [d at: tokens second put: tokens first]].
	^d! !

!MIMEDocument class methodsFor: 'content-types' stamp: 'bolot 5/16/1999 12:25'!
contentTypeFormData
	^'application/x-www-form-urlencoded'! !

!MIMEDocument class methodsFor: 'content-types' stamp: 'bolot 5/16/1999 13:05'!
contentTypeHtml
	^'text/html'! !

!MIMEDocument class methodsFor: 'content-types' stamp: 'bolot 5/16/1999 12:25'!
contentTypeMultipart
	^'multipart/form-data'! !

!MIMEDocument class methodsFor: 'content-types' stamp: 'bolot 5/16/1999 13:05'!
contentTypePlainText
	^'text/plain'! !

!MIMEDocument class methodsFor: 'content-types' stamp: 'bolot 5/16/1999 13:05'!
contentTypeXml
	^'text/xml'! !

!MIMEDocument class methodsFor: 'content-types' stamp: 'bolot 9/9/1999 15:21'!
guessTypeFromExtension: ext
	"guesses a content type from the extension"
	| extension |
	extension _ ext asString.
	(extension includes: $.) ifTrue: [ ^self defaultContentType].

	MIMEdatabase ifNil: [MIMEdatabase _ self defaultMIMEdatabase].
	^ MIMEdatabase at: extension ifAbsent: [self defaultContentType].! !

!MIMEDocument class methodsFor: 'content-types' stamp: 'bolot 4/23/1999 17:57'!
guessTypeFromName: url
	"guesses a content type from the url"
	| extension |
	extension _ url asString.
	(extension includes: $.) ifFalse: [ ^self defaultContentType].

	extension _ (extension findTokens: '.') last asLowercase.

	MIMEdatabase ifNil: [MIMEdatabase _ self defaultMIMEdatabase].
	^ MIMEdatabase at: extension ifAbsent: [self defaultContentType].
! !

!MIMEDocument class methodsFor: 'content-types' stamp: 'bolot 9/9/1999 15:21'!
linkExtension: ext toType: mimeType
	MIMEdatabase at: ext asString put: mimeType asString! !


!MultipartPostModule commentStamp: 'bolot 8/20/1999 10:11' prior: 0!
MultipartPostModule
helper module
not a standalone module

sole purpose is to
- read the multipart form
- save results in files

PRE:
- http request with header completed

POST:
- http request with body completed

IMPLEMENTATION NOTES:
IE4 for Mac appends 128 bytes of Mac file system info
this fix assumes that the first chunk (body) is at least 128 bytes
(the below info could be used for setting type/creator)
	bytes	content
	0		0
	1		file name length
	2..N		file name
	66..69	file type
	70..73	file creator
!

!MultipartPostModule methodsFor: 'processing' stamp: 'bolot 7/14/1999 17:24'!
filter: request
	(request method = 'POST' and: [request contentType = MIMEDocument contentTypeMultipart])
		ifTrue: [^request].
	^nil! !

!MultipartPostModule methodsFor: 'processing' stamp: 'bolot 9/11/1999 15:44'!
process: request
	" process multipart form data "
	" save files in the temporary directory, with temporary names "
" TODO: save other form data "
	| hdr body boundary str idx origFileName fileName file fieldName contentType formDict doc |
	(self filter: request)
		ifNil: [^request].

	formDict _ Dictionary new.
	boundary _ request multipartFormDataBoundary.
"Transcript show: 'Boundary = ', boundary; cr."
	[hdr _ request stream getSubHeader.
	hdr isEmptyOrNil ifTrue: [request privPostFields: formDict. ^request].
"Transcript show: hdr asString; cr."
	str _ (hdr at: 'content-disposition' ifAbsent: ['']).

	fileName _ fieldName _ ''.

	idx _ str findString: 'filename='.
	idx > 0 ifTrue: [fileName _ str copyFrom: idx + 10 to: (str indexOf: $" startingAt: idx+10) - 1].

	idx _ str findString: 'name='.
	idx > 0 ifTrue: [fieldName _ str copyFrom: idx + 6 to: (str indexOf: $" startingAt: idx+6) - 1].

	contentType _ hdr at: 'content-type' ifAbsent: [MIMEDocument defaultContentType].
"Transcript show: 'field=', fieldName; cr; show: 'file=', fileName; cr;
	show: 'content-type=', contentType; cr."

	origFileName _ fileName.
	(fileName size > 0 and: [Comanche allowUploads])
		ifTrue: [fileName _ (fileName findTokens: ':/\') last.
			fileName _ (FileDirectory checkName: fileName fixErrors: true) asLowercase unescapePercents.
			file _ tempDir fileNamed: fileName]
		ifFalse: [file _ DummyStream on: String new. fileName _ nil].
" TODO: parse regular form data "
" TODO: create IgnoreStream "

"Transcript show: 'reading body...'; cr."
	body _ request stream nextChunk.
	"IE4 for Mac appends 128 bytes of Mac file system info - must remove"
	"this fix assumes that body size >= 128"
	((body at: 1) asciiValue = 0
			and: [(body at: 2) asciiValue = origFileName size
				and: [(body copyFrom: 3 to: origFileName size + 2) = origFileName]])
		ifTrue: [body _ body copyFrom: 129 to: body size].
"Transcript show: 'init body=', body; cr."
	[(idx _ body findString: boundary) = 0]
		whileTrue:
			[idx _ body size - boundary size + 1 max: 1.
" Transcript show: 'idx=', idx asString; cr. "
			str _ request stream nextChunk.
" Transcript show: 'str=', str; cr;
	show: 'file=', (body copyFrom: 1 to: idx); cr. "
			file nextPutAll: (body copyFrom: 1 to: idx - 1).
			body _ (body copyFrom: idx to: body size) , str].
	" save the last chunk in the file "
	file nextPutAll: (body copyFrom: 1 to: idx-5). " idx-1 - String crlf size "
	file close.
	fileName
		ifNotNil:
			[doc _ MIMEDocument contentType: contentType content: ''
				url: (String streamContents: [:stream |
					stream nextPutAll: 'file://'.
					(tempDir pathName findTokens: FileDirectory slash)
						do: [:piece |
							stream nextPutAll: piece; nextPut: $/].
					stream nextPutAll: fileName]).
			formDict at: fieldName put: doc].

	request stream putDataBack: (body copyFrom: idx-4 to: body size).
	request stream atEnd or: [hdr isNil]
	] whileFalse.

	request privPostFields: formDict.

	^request! !


!ObjectServerModule methodsFor: 'processing' stamp: 'bolot 8/16/1999 14:31'!
fileInFromRequest: request
	"assumption: POST, body=SmartRefStream"

	| srefStream string |
	string _ request stream upToEnd.
	srefStream _ RWBinaryOrTextStream on: (String new: request contentLength).
	srefStream nextPutAll: string; reset.
	^srefStream fileInObjectAndCode! !

!ObjectServerModule methodsFor: 'processing' stamp: 'bolot 8/16/1999 13:32'!
filter: rawRequest
	| request query uid |
	rawRequest getFields isEmptyOrNil ifTrue: [^nil].
	(rawRequest url beginsWith: '/', self name)
		ifFalse: [^nil].
	(query _ rawRequest getFields at: 'query' ifAbsent: [nil])
		ifNil: [^nil].
	request _ ObjectServerRequest fromRequest: rawRequest.
	uid _ rawRequest getFields at: 'uid' ifAbsent: [nil].
	request privQuery: query; privUid: uid.	
	^request! !

!ObjectServerModule methodsFor: 'processing' stamp: 'bolot 8/16/1999 14:44'!
processBeforeModules: request
	(self processQuery: request)
		ifFalse: [request badRequest].

	^request! !

!ObjectServerModule methodsFor: 'processing' stamp: 'bolot 8/18/1999 19:50'!
processQuery: request
	"return true/false - if handled"
	| anObject |
	request query caseOf:
	{
	['getclass']->[
		anObject _ request getFields at: 'classname' ifAbsent: [].
		anObject _ Smalltalk at: anObject asSymbol ifAbsent: [anObject].
		(anObject isKindOf: Class)
			ifTrue: [self sendClass: anObject onRequest: request]
			ifFalse: [request notFound]].
	['getchangeset']->[
		anObject _ request getFields at: 'changesetname' ifAbsent: [].
		anObject _ ChangeSorter changeSetNamed: anObject.
		(anObject isKindOf: ChangeSet)
			ifTrue: [self sendChangeSet: anObject onRequest: request]
			ifFalse: [request notFound]].
	['getobject']->[
		"return an object by ID..."].
	['putobject']->[
		self fileInFromRequest: request]
	} otherwise: [^false].

	^true! !

!ObjectServerModule methodsFor: 'processing' stamp: 'bolot 8/18/1999 19:41'!
sendChangeSet: aChangeSet onRequest: request
	| srefStream |
	srefStream _ RWBinaryOrTextStream on: String new.
	aChangeSet checkForConversionMethods.
	srefStream header; timestamp.
	aChangeSet fileOutPreambleOn: srefStream.
	aChangeSet fileOutOn: srefStream.
	aChangeSet fileOutPostscriptOn: srefStream.
	srefStream trailer; close.
	DeepCopier new checkVariables.
	request responseHeaderAt: 'Content-type' put: MIMEDocument contentTypeBinary;
		responseHeaderAt: 'Content-length' put: srefStream contents size printString;
		sendHeaderWithStatus: #success.
	request stream nextPutAll: srefStream contents! !

!ObjectServerModule methodsFor: 'processing' stamp: 'bolot 8/12/1999 16:43'!
sendClass: aClass onRequest: request
	| srefStream |
	srefStream _ RWBinaryOrTextStream on: String new.
	srefStream fileOutClass: aClass andObject: 'signature'.
	request responseHeaderAt: 'Content-type' put: MIMEDocument contentTypeBinary;
		responseHeaderAt: 'Content-length' put: srefStream contents size printString;
		sendHeaderWithStatus: #success.
	request stream nextPutAll: srefStream contents! !

!ObjectServerModule methodsFor: 'processing' stamp: 'bolot 8/12/1999 18:05'!
sendObject: anObject onRequest: request
	| srefStream |
	srefStream _ RWBinaryOrTextStream on: String new.
	srefStream fileOutClass: nil andObject: anObject.
	request responseHeaderAt: 'Content-type' put: MIMEDocument contentTypeBinary;
		responseHeaderAt: 'Content-length' put: srefStream contents size printString;
		sendHeaderWithStatus: #success.
	request stream nextPutAll: srefStream contents! !


!ObjectServerRequest methodsFor: 'accessing' stamp: 'bolot 8/15/1999 23:42'!
privQuery: aQuery
	query _ aQuery! !

!ObjectServerRequest methodsFor: 'accessing' stamp: 'bolot 8/15/1999 23:42'!
privUid: aUid
	uid _ aUid! !

!ObjectServerRequest methodsFor: 'accessing' stamp: 'bolot 8/15/1999 23:43'!
query
	^query! !

!ObjectServerRequest methodsFor: 'accessing' stamp: 'bolot 8/15/1999 23:43'!
uid
	^uid! !


!PingModule methodsFor: 'processing' stamp: 'bolot 5/18/1999 01:46'!
filter: rawRequest
	rawRequest method = 'PING'
		ifTrue: [^rawRequest]
		ifFalse: [^nil]! !

!PingModule methodsFor: 'processing' stamp: 'bolot 5/18/1999 01:47'!
process: request
	request stream nextPutAll: 'HTTP/1.1 200 OK', String crlf, String crlf,
		'some statistics in XML format'! !


!PwsModule commentStamp: 'bolot 9/10/1999 21:10' prior: 0!
Compatibility module for running PWS actions
PWS actions are set up in the regular manner
(PWS actions at: 'key' put: anAction, or use linkTo, etc.)
Then PwsModule uses PWS actions table!

!PwsModule methodsFor: 'pws api' stamp: 'bolot 5/16/1999 18:42'!
actions
	^PWS actions! !

!PwsModule methodsFor: 'processing' stamp: 'bolot 8/11/1999 23:53'!
filter: rawRequest
	| request fields userId message |
	message _ rawRequest url findTokens: '/.\?:='.

	(PWS actions includesKey: message first)
		ifFalse: [^nil].

	request _ PwsRequest fromRequest: rawRequest.

	request getFields
		ifNil: [fields _ Dictionary new]
		ifNotNil: [fields _ request getFields].
	request postFields
		ifNotNil: [request postFields associationsDo: [:a | fields at: a key put: a value]].

	userId _ request user.

	request
		privFields: fields;
		privMessage: message;
		privUserId: userId;
		privPeerName: nil;
		privAction: (PWS actions at: message first).

	^request! !

!PwsModule methodsFor: 'processing' stamp: 'bolot 8/12/1999 00:15'!
process: rawRequest
	| request |
	(request _ self filter: rawRequest)
		ifNil: [^rawRequest].

	"Transcript show: request printString; cr."
	[request action process: request]
		ifError: [:err :rcvr |
			request log: '*** ', rcvr asString, ': ', err.
			[(err beginsWith: 'HTTP')
				ifFalse: [request badRequest].
			request stream nextPutAll: err] ifError: [:m :r | "ignore errors"]].

	^request! !


!PwsRequest methodsFor: 'pws api' stamp: 'bolot 5/16/1999 18:14'!
fields
	^fields! !

!PwsRequest methodsFor: 'pws api' stamp: 'bolot 5/16/1999 18:14'!
log
	^log! !

!PwsRequest methodsFor: 'pws api' stamp: 'bolot 8/11/1999 23:53'!
log: str
	log ifNotNil: [log nextPutAll: str]! !

!PwsRequest methodsFor: 'pws api' stamp: 'bolot 5/16/1999 18:15'!
message
	^message! !

!PwsRequest methodsFor: 'pws api' stamp: 'bolot 5/16/1999 18:15'!
message: array
	message _ array! !

!PwsRequest methodsFor: 'pws api' stamp: 'bolot 5/16/1999 18:17'!
peerName
	^peerName! !

!PwsRequest methodsFor: 'pws api' stamp: 'bolot 5/16/1999 18:17'!
reply: str
	stream nextPutAll: str! !

!PwsRequest methodsFor: 'pws api' stamp: 'bolot 5/16/1999 18:36'!
replyStream: file
	stream serveFile: file! !

!PwsRequest methodsFor: 'pws api' stamp: 'bolot 5/16/1999 18:17'!
userId
	^userId! !

!PwsRequest methodsFor: 'private' stamp: 'bolot 5/16/1999 18:43'!
action
	^action! !

!PwsRequest methodsFor: 'private' stamp: 'bolot 5/16/1999 18:43'!
privAction: str
	action _ str! !

!PwsRequest methodsFor: 'private' stamp: 'bolot 5/16/1999 18:36'!
privFields: dict
	fields _ dict! !

!PwsRequest methodsFor: 'private' stamp: 'bolot 5/16/1999 18:34'!
privMessage: coll
	message _ coll! !

!PwsRequest methodsFor: 'private' stamp: 'bolot 5/16/1999 18:33'!
privPeerName: str
	peerName _ str! !

!PwsRequest methodsFor: 'private' stamp: 'bolot 5/16/1999 18:33'!
privUserId: str
	userId _ str! !


!PwsRequest class methodsFor: 'instance creation' stamp: 'bolot 8/11/1999 23:51'!
for: module fromRequest: rawRequest
	| request fields userId message |
	message _ rawRequest url findTokens: '/.\?:='.

	(PWS actions includesKey: message first)
		ifFalse: [^nil].

	request _ self fromRequest: rawRequest.

	request getFields
		ifNil: [fields _ Dictionary new]
		ifNotNil: [fields _ request getFields].
	request postFields
		ifNotNil: [request postFields associationsDo: [:a | fields at: a key put: a value]].

	userId _ request user.

	request
		privFields: fields;
		privMessage: message;
		privUserId: userId;
		privPeerName: nil;
		privAction: (PWS actions at: message first).

	^request! !


!RedirectModule commentStamp: 'bolot 9/10/1999 21:41' prior: 0!
RedirectModule

use a redirectMap to forward GET requests to their new location
currently, assume PWS-style Swiki redirects
i.e., /myswiki.N -> http://newplace/myswiki.N

redirModule addMappingFrom: 'cnn' to: 'http://cnn.com/'
!

!RedirectModule methodsFor: 'initialization' stamp: 'bolot 8/19/1999 20:23'!
initialize
	super initialize.
	redirectMap _ Dictionary new! !

!RedirectModule methodsFor: 'processing' stamp: 'bolot 8/19/1999 20:32'!
process: request
	"combine filter: and process:"
	| coreRef index oldUrl |
	oldUrl _ request url.
	index _ oldUrl indexOfAnyOf: '?/\.' asCharacterSet startingAt: 2.
	index > 0 ifFalse: [index _ oldUrl size + 1].
	coreRef _ oldUrl copyFrom: 2 to: index - 1.
	redirectMap at: coreRef ifPresent: [:newUrl |
		request redirectTo: newUrl, (oldUrl copyFrom: index to: oldUrl size)].
	^request! !

!RedirectModule methodsFor: 'accessing' stamp: 'bolot 8/19/1999 19:25'!
addMappingFrom: oldUrl to: newUrl
	redirectMap at: oldUrl put: newUrl! !

!RedirectModule methodsFor: 'accessing' stamp: 'bolot 8/19/1999 19:25'!
removeMappingFrom: oldUrl
	redirectMap removeKey: oldUrl ifAbsent: []! !


!RedirectModule class methodsFor: 'instance creation' stamp: 'bolot 8/19/1999 20:33'!
newModuleNamed: aName withRedirects: array
	"RedirectModule newModuleNamed: 'redirect'
		withRedirects: #( ('cnn' 'http://cnn.com')
			('excite' 'http://www.excite.com'))"
	| m oldUrl newUrl |
	m _ self newModuleNamed: aName.
	array do: [:elem | oldUrl _ elem first. newUrl _ elem second.
		m addMappingFrom: oldUrl to: newUrl].
	^m! !

"Smalltalk renameClassNamed: #HttpStream as: #SocketStream"!

!SocketStream commentStamp: 'bolot 9/10/1999 21:09' prior: 0!
SocketStream
- stream interface to Socket
- HttpRequest (and other users) don't know anything about sockets!

!SocketStream reorganize!
('initialization' fastHeader: header: initialize readHeader socket:)
('accessing' atEnd close contentLength cr crlf getSubHeader header isConnected next next: nextChunk nextPut: nextPutAll: putDataBack: remoteAddress status upTo: upToEnd)
('private' inDataCount outDataCount)
!


!SocketStream methodsFor: 'initialization' stamp: 'bolot 8/11/1999 14:48'!
fastHeader: string
	| key value start end more colonPos fieldDelims statusLine lastKey keyValueDelim |
	"TODO: support multi-line headers (if line starts with a separator, append to last"
	header _ Dictionary new.
	status _ Dictionary new.
	string isEmptyOrNil ifTrue: [^self].
	fieldDelims _ String crlf asCharacterSet.
	keyValueDelim _ $:.
	more _ true.
	start _ 1.
	end _ string indexOfAnyOf: fieldDelims startingAt: start.
	end == 0
		ifTrue: [^self].
	statusLine _ (string copyFrom: start to: end-1) findTokens: ' '.
	statusLine size = 3
		ifTrue: [status
			at: #method put: statusLine first;
			at: #url put: statusLine second;
			at: #protocol put: statusLine third].
	start _ string skipDelimiters: String crlf startingAt: end.
	lastKey _ ''.
	[end _ string indexOfAnyOf: fieldDelims startingAt: start.
	end == 0
		ifTrue: [end _ string size. more _ false]
		ifFalse: [end _ end - 1].
	(end >= start and: [start < string size])
		ifTrue: [
			(string at: start) isSeparator
				ifTrue: [header at: lastKey put: ((header at: lastKey), (string copyFrom: start to: end))]
				ifFalse: [colonPos _ string indexOf: keyValueDelim startingAt: start.
					(colonPos > end or: [colonPos == 0])
						ifTrue: [key _ (key _ string copyFrom: start to: end) asLowercase.
							value _ '']
						ifFalse: [key _ (key _ string copyFrom: start to: colonPos-1) asLowercase.
							value _ (value _ string copyFrom: colonPos+1 to: end) withBlanksTrimmed]].
			key isEmpty
				ifFalse: [header at: key put: value.
					lastKey _ key.
					key _ ''].
			start _ string skipDelimiters: String crlf startingAt: end+1].
	more] whileTrue! !

!SocketStream methodsFor: 'initialization' stamp: 'bolot 5/6/1999 20:31'!
header: string
	"divide into basic lines"
	" based on HTTPSocket header: code "
	| lines foldedLines i statusLine |
	lines _ string findTokens: String crlf.
	statusLine _ (lines first) findTokens: ' '.
	lines _ lines copyFrom: 2 to: lines size.

	"parse the status (pretty trivial right now)"
	(status _ Dictionary new)
		at: #method put: statusLine first;
		at: #url put: statusLine second;
		at: #protocol put: statusLine third.

	"fold lines that start with spaces into the previous line"
	foldedLines _ OrderedCollection new.
	lines do: [ :line |
		line first isSeparator ifTrue: [
			foldedLines at: foldedLines size  put: (foldedLines last, line) ]
		ifFalse: [ foldedLines add: line ] ].

	"make a dictionary mapping headers to header contents"
	header _ Dictionary new.
	foldedLines do: [ :line |
		i _ line indexOf: $:.
		i > 0 ifTrue: [
			header
			at: (line copyFrom: 1 to: i-1) asLowercase 
			put: (line copyFrom: i+1 to: line size) withBlanksTrimmed ] ]..
! !

!SocketStream methodsFor: 'initialization' stamp: 'bolot 5/6/1999 19:26'!
initialize
	inDataCount _ outDataCount _ 0! !

!SocketStream methodsFor: 'initialization' stamp: 'bolot 9/2/1999 21:01'!
readHeader
	| headerString dataArray crlf |
	crlf _ String crlf.
	[dataArray _ socket getResponseUpTo: crlf, crlf.
	headerString _ dataArray at: 1.
	buffer _ dataArray at: 3.
	inDataCount _ headerString size + buffer size + crlf size.
	self fastHeader: headerString]
		ifError: [:err :rcvr | socket destroy. ^nil].! !

!SocketStream methodsFor: 'initialization' stamp: 'bolot 5/6/1999 19:37'!
socket: s
	socket _ s! !

!SocketStream methodsFor: 'accessing' stamp: 'bolot 9/9/1999 16:53'!
atEnd
	^socket isConnected not and: [buffer isEmptyOrNil and: [socket dataAvailable not]]! !

!SocketStream methodsFor: 'accessing' stamp: 'bolot 9/9/1999 16:54'!
close
	socket closeAndDestroy: 30.
	buffer _ ''! !

!SocketStream methodsFor: 'accessing' stamp: 'bolot 5/16/1999 14:05'!
contentLength
	^(header at: 'content-length' ifAbsent: [0]) asNumber! !

!SocketStream methodsFor: 'accessing' stamp: 'bolot 5/16/1999 14:34'!
cr
	self nextPutAll: String crlf! !

!SocketStream methodsFor: 'accessing' stamp: 'bolot 8/11/1999 22:13'!
crlf
	self nextPutAll: String crlf! !

!SocketStream methodsFor: 'accessing' stamp: 'bolot 8/18/1999 17:47'!
getSubHeader
	" return a MIME section header "
	| i result string dict |
	string _ buffer.
	buffer _ ''.
	[(i _ string findString: String crlf, String crlf) > 0
		ifTrue: [result _ string copyFrom: 1 to: i-1.
			buffer _ string copyFrom: i to: string size.
			self next: 4. " ignore CRLFCRLF "
			^HttpRequest parseHeader: result].
	socket isConnected and: [socket dataAvailable]]
		whileTrue:
	[string _ string, socket getData].
	result _ string.
	dict _ HttpRequest parseHeader: result.
	dict isEmptyOrNil ifFalse: [self next: 4]. " ignore CRLFCRLF "
	^dict! !

!SocketStream methodsFor: 'accessing' stamp: 'bolot 5/6/1999 20:32'!
header
	^header! !

!SocketStream methodsFor: 'accessing' stamp: 'bolot 8/9/1999 15:15'!
isConnected
	^socket isConnected! !

!SocketStream methodsFor: 'accessing' stamp: 'bolot 8/18/1999 13:11'!
next
	| c |
	self atEnd ifTrue: [^nil].
	buffer isEmpty ifTrue: [buffer _ socket getData. inDataCount _ inDataCount + buffer size].
	c _ buffer first.
	buffer _ buffer copyFrom: 2 to: buffer size.
	^c! !

!SocketStream methodsFor: 'accessing' stamp: 'bolot 8/18/1999 13:11'!
next: n
	| string |
	buffer size >= n
		ifTrue: [string _ buffer copyFrom: 1 to: n.
			buffer _ buffer copyFrom: n+1 to: buffer size.
			^string].
	string _ buffer.
	buffer _ ''.
	(socket isConnected not or: [socket dataAvailable not])
		ifTrue: [^string].
	buffer _ socket getData.
	inDataCount _ inDataCount + buffer size.
	^ string , (self next: (n - string size))! !

!SocketStream methodsFor: 'accessing' stamp: 'bolot 8/18/1999 17:51'!
nextChunk
	"getData front - retrieve all data available now"
	| string |
	buffer size > 0
		ifTrue: [string _ buffer. buffer _ '']
		ifFalse: [string _ socket getData. inDataCount _ inDataCount + string size].
	^string! !

!SocketStream methodsFor: 'accessing' stamp: 'bolot 8/18/1999 13:09'!
nextPut: char
	socket sendData: char asString.
	outDataCount _ outDataCount + 1! !

!SocketStream methodsFor: 'accessing' stamp: 'bolot 8/18/1999 13:09'!
nextPutAll: string
	socket isConnected
		ifTrue: [socket sendData: string. outDataCount _ outDataCount + string size]! !

!SocketStream methodsFor: 'accessing' stamp: 'bolot 5/21/1999 02:54'!
putDataBack: string
	buffer _ string, buffer! !

!SocketStream methodsFor: 'accessing' stamp: 'bolot 5/6/1999 20:41'!
remoteAddress
	^socket remoteAddress! !

!SocketStream methodsFor: 'accessing' stamp: 'bolot 5/6/1999 20:32'!
status
	^status! !

!SocketStream methodsFor: 'accessing' stamp: 'bolot 5/6/1999 19:32'!
upTo: delim 
	"Fast version to speed up nextChunk"
	| count |
	buffer _ buffer, self next: 2000.
	(count _ buffer indexOf: delim) > 0 ifTrue: 
		["Found the delimiter part way into buffer"
		^ buffer copyFrom: 1 to: count - 1].
	self atEnd ifTrue:
		["Never found it, and hit end of file"
		^ buffer].
	"Never found it, but there's more..."
	^ buffer , (self upTo: delim)! !

!SocketStream methodsFor: 'accessing' stamp: 'bolot 5/16/1999 14:05'!
upToEnd
	| rest |
	rest _ socket getRestOfBuffer: buffer totalLength: self contentLength.
	buffer _ ''.
	(rest isKindOf: String) ifTrue: [^'']. " error "
	^rest contents
! !

!SocketStream methodsFor: 'private' stamp: 'bolot 8/18/1999 13:10'!
inDataCount
	^inDataCount! !

!SocketStream methodsFor: 'private' stamp: 'bolot 8/18/1999 13:10'!
outDataCount
	^outDataCount! !


!SocketStream class methodsFor: 'instance creation' stamp: 'bolot 5/15/1999 15:12'!
on: socket
	^self basicNew initialize; socket: socket; readHeader! !


AccessControlList removeSelector: #denyThenAllow!
AccessControlList removeSelector: #allowThenDeny!
Comanche initialize!
ComancheModule removeSelector: #logToFileNamed:!
AccessControlModule removeSelector: #privRealm:!
ComancheModule class removeSelector: #swikiWebServer!
FileServerModule removeSelector: #processAfterModules:!
HttpRequest removeSelector: #privTimestampe:!
HttpRequest removeSelector: #timestamp!
HttpRequest removeSelector: #privContentType:!
HttpRequest removeSelector: #sendHeaderWithStatus:httpVersion:!
HttpRequest removeSelector: #body!
HttpRequest removeSelector: #privMethod:!
HttpRequest removeSelector: #privTimestamp:!
HttpRequest removeSelector: #initialize!
HttpRequest removeSelector: #privBody:!
HttpRequest removeSelector: #privProtocol:!
HttpRequest removeSelector: #privHeader:!
HttpRequest initialize!
MIMEDocument class removeSelector: #initializeMIMEdatabaseFrom:!
MultipartPostModule removeSelector: #processBeforeModules:!
Smalltalk removeClassNamed: #HttpResponse!
Smalltalk removeClassNamed: #LogModule!
Smalltalk removeClassNamed: #HttpStream!
